{%- assign separator = site.title_separator | default: " | " -%}
{%- if page.title %}
  {% if page.url == "/index.html" %}
    {% assign seo_title = site.title | append: separator | append: site.tagline %}
  {% else %}
    {% assign seo_title = page.title | append: separator | append: site.title %}
  {% endif %}
  {% assign seo_page_title = page.title %}
{% else %}
  {% assign seo_title = site.title %}
  {% assign seo_page_title = site.title %}
  {% if site.description %}
    {% assign seo_title = seo_title | append: separator | append: site.description %}
  {% endif %}
{% endif -%}
{%- assign seo_description = page.description | default: page.excerpt -%}
{% if seo_description %}
{% assign seo_description = seo_description | markdownify %}
{% else %}
  {% assign seo_description = page.content | markdownify | split: '</p>' | first | default: site.description %}
{% endif %}
{% assign seo_description = seo_description | strip_html | normalize_whitespace %}

{%- assign canonical_url = page.url | strip_index | absolute_url %}

  <title>{{ seo_title }}</title>
  <meta property="og:title" content="{{ seo_page_title }}" >
  <meta property="twitter:title" content="{{ seo_page_title }}" >

  <meta name="description" content="{{ seo_description | truncate: 150, '' | escape_once }}" >
  <meta property="og:description" content="{{ seo_description | truncatewords: 50 | escape_once }}" >
  <meta property="twitter:description" content="{{ seo_description | truncatewords: 50 | escape_once }}" >

{%- if page.author %}
  <meta name="author" content="{{ page.author }}" >
{% endif %}

  <meta name="language" content="{{ page.lang | default: site.locale | slice: 0,2 | default: 'en' }}" >
  <meta property="og:locale" content="{{ page.locale | default: site.locale | default: 'en-US' | replace:'-','_' }}" >

{%- if site.url and page.url %}
  <link rel="canonical" href="{{ canonical_url }}">
  <meta property="og:url" content="{{ canonical_url }}" >
  <meta property="twitter:url" content="{{ canonical_url }}" >
{% endif %}

  <meta property="og:site_name" content="{{ site.title }}" >

{%- if page.page_type %}
  <meta property="og:type" content="{{ page.page_type }}" >
{% elsif page.date %}
  <meta property="og:type" content="article" >
  <meta property="article:published_time" content="{{ page.date | date_to_xmlschema }}" >
{% else %}
  <meta property="og:type" content="website" >
{% endif %}

{%- if paginator.previous_page %}
  <link rel="prev" href="{{ paginator.previous_page_path | absolute_url }}">
{% endif -%}
{%- if paginator.next_page %}
  <link rel="next" href="{{ paginator.next_page_path | absolute_url }}">
{% endif %}

{%- assign social_image = page.image.social | default: page.image.cover -%}
{%- if social_image %}
  <meta property="og:image" content="{{ social_image |  | absolute_url }}" >
  <meta name="twitter:image" content="{{ social_image |  | absolute_url }}" >
{% endif -%}

{%- if site.twitter %}
  {%- if seo_page_image or page.image.twitter %}
    <meta name="twitter:card" content="summary_large_image" >
    <meta nema="twitter:image" content="{{ page.image.twitter | default: seo_page_image | absolute_url }}" >
  {% else %}
    <meta name="twitter:card" content="summary" >
  {% endif %}

  <meta name="twitter:site" content="@{{ site.twitter.username | replace:"@","" }}" >
{% endif %}

{%- if site.facebook %}
  {% if site.facebook.admins %}
    <meta property="fb:admins" content="{{ site.facebook.admins }}" >
  {% endif %}

  {% if site.facebook.publisher %}
    <meta property="article:publisher" content="{{ site.facebook.publisher }}" >
  {% endif %}

  {% if site.facebook.app_id %}
    <meta property="fb:app_id" content="{{ site.facebook.app_id }}" >
  {% endif %}
{% endif %}

{%- if page.url == "/" and site.webmaster_verification %}
  {% if site.webmaster_verification.google %}
    <meta name="google-site-verification" content="{{ site.webmaster_verification.google }}">
  {% endif %}
  {% if site.webmaster_verification.bing %}
    <meta name="msvalidate.01" content="{{ site.webmaster_verification.bing }}">
  {% endif %}
  {% if site.webmaster_verification.alexa %}
    <meta name="alexaVerifyID" content="{{ site.webmaster_verification.alexa }}">
  {% endif %}
  {% if site.webmaster_verification.yandex %}
    <meta name="yandex-verification" content="{{ site.webmaster_verification.yandex }}">
  {% endif %}
{% endif %}

{%- if page.git %}
  <meta name="page-commit" content="{{ page.git.last_commit.short_sha }}" >
  <meta name="page-commit-date" content="{{ page.git.last_commit.commit_date | date_to_xmlschema }}" >
{% endif -%}

{% if page.redirect_to %}
<link rel="canonical" href="{{ page.redirect_to }}"/>
<meta http-equiv="refresh" content="0;url={{ page.redirect_to }}" />
<script>location='{{ page.redirect_to }}'</script>
{% endif %}
